/* chorus.c
 * ------------------------------------------------------------------------
 *
 * Copyright (C) 2000 Stefan Fendt <stefan@lionfish.ping.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * ------------------------------------------------------------------------
 * This is a not so simple chorus effect anymore :).
 */

#include <math.h>
#include <stdio.h>
#include "osc.h"

float chorus(float invalue,float dry)
{
  static float ring[2048];
  static int   count1,
               offset1;
         float outvalue;

  count1++;
  count1 &= 2047;

  offset1=(int)( osc(7,.08,0,0,0)* 512 );

  ring[count1]=invalue;
  outvalue=ring[(count1-offset1-1024)&2047];
  outvalue+=invalue;
  outvalue/=2;

  return outvalue*(dry)+invalue*(1-dry);
}







