/* file_io.c
 * 
 * We need something to read/write signed-word samples. This
 * might be sub-optimal coding, so if you know a better 
 * variant please let me know
 * 
 * ------------------------------------------------------------------------
 *
 * Copyright (C) 2000 Stefan Fendt <stefan@lionfish.ping.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * ------------------------------------------------------------------------
 */

unsigned char WAVheader[] =
{   
     'R','I','F','F',
     0x00,0x00,0x00,0x00,
     'W','A','V','E','f','m','t',' ',
     0x10,0x00,0x00,0x00,
     0x01,0x00,
     0x01,0x00,     
     0x44,0xAC,0x00,0x00,
     0x88,0x58,0x01,0x00,
     0x02,0x00,
     0x10,0x00,
     'd','a','t','a',
     0x00,0x00,0x00,0x00
};

void init_wav_header(int rate, int channels, int length)
{
  /* set samplerate (not needed jet) */
  
  /* set nr. of channels (not needed jet) */

  /* set filelength */
  length *= 2; /* samples are words... */
   
  WAVheader[7]=(unsigned char)(((length+36) >> 24 ) & 255);
  WAVheader[6]=(unsigned char)(((length+36) >> 16 ) & 255);
  WAVheader[5]=(unsigned char)(((length+36) >> 8  ) & 255);
  WAVheader[4]=(unsigned char)(((length+36)       ) & 255);
 
  WAVheader[43]=(unsigned char)((length >> 24 ) & 255);
  WAVheader[42]=(unsigned char)((length >> 16 ) & 255);
  WAVheader[41]=(unsigned char)((length >> 8  ) & 255);
  WAVheader[40]=(unsigned char)((length       ) & 255);
}

void write_wav_header(FILE *fp)
{
  int i;
  for(i=0;i<44;i++)
    {
      putc(WAVheader[i],fp);
    }
}

void putsample(FILE *fp,int sample)
{
  unsigned char hibyte,
                lobyte;
  
  if(sample>32767) sample=32767;
  if(sample<-32767) sample=-32767;

  lobyte=sample & 255;
  hibyte=sample >> 8;

  putc(lobyte,fp);
  putc(hibyte,fp);
}








