/* token.h
 * ------------------------------------------------------------------------
 *
 * Copyright (C) 2000 Stefan Fendt <stefan@lionfish.ping.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 *
 * ------------------------------------------------------------------------
 * 
 * This allows to easiely add even more parameters ...
 * I especially think of a modulation-matrix or hard-synced Oscillators 
 * (the code of the oscillators is designed for that) 
 * What do you think of ringmodulation ?
 * 
 * NOTE ON 28th of Jan. : The parser does *not* do any kind of error-checking.
 *                        This is intentional. Real analouge synths do not have
 *                        error-checks either... So be aware what you do in your
 *                        .synth-file !!!
 *                        FM-Modulation can be done easiely by using the "low"-
 *                        frequency-oscillators with high frequencies :-)
 */

float chorus_level;
float phaser_level;
float master_vol;
float osc_out[6];
float osc_freq[6],    osc_wave[6],    osc_ampl[6];
float osc_mul=1;
float attack[12],     decay[12],      sustain[12],    release[12];
float att_val[12],    dec_val[12];
float flt_attack,     flt_decay,      flt_sustain,    flt_release;
float res_attack,     res_decay,      res_sustain,    res_release;
float flt_att_val,    flt_dec_val;
float res_att_val,    res_dec_val;
float hflt_attack,    hflt_decay,     hflt_sustain,   hflt_release;
float hres_attack,    hres_decay,     hres_sustain,   hres_release;
float hflt_att_val,   hflt_dec_val;
float hres_att_val,   hres_dec_val;
float sh_time,        sh_reg1,        sh_reg2;
float drive;
float delaytime,      delaylevel,     delayfeedback,   delayaddition;
int modmatrix[6][7]={{0,0,0,0,0,0,1},
		     {0,0,0,0,0,0,1},
		     {0,0,0,0,0,0,1},
		     {0,0,0,0,0,0,1},
		     {0,0,0,0,0,0,1},
		     {0,0,0,0,0,0,1}};
int osc_trans[6]={1,1,1,1,1,1};
float vowel_time=0;
char vowel_string[1024];
